<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 21/03/19
 * Time: 14.49
 */

namespace FiloBlu\RuleDayFromBirthday\Model\Rule\Condition\Quote;




use Magento\SalesRule\Api\CouponRepositoryInterface;
use Magento\SalesRule\Model\Coupon;
use Magento\Framework\App\RequestInterface;
use Magento\Checkout\Model\Session;
use Magento\Framework\Message\ManagerInterface;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Store\Model\StoreManagerInterface;
use Magento\Customer\Model\Session as CustomerSession;
use Magento\Customer\Model\ResourceModel\CustomerRepository;

class SubtotalWithDiscountNoShipping extends \Magento\Rule\Model\Condition\AbstractCondition
{


    protected $couponRepository;
    protected $coupon;
    protected $request;
    protected $session;
    protected $manager;
    protected $scopeConfig;
    protected $storeManager;
    protected $customerSession;
    protected $customerRepository;
    const VALIDATION_MODE = 'filoblu_ruledayfrombirthday_section/birthday_coupon_id/validation_selector';
    const EXPIRATION_VALUE = 'filoblu_ruledayfrombirthday_section/birthday_coupon_id/validation_range_text';


    /**
     * Birthday constructor.
     * @param \Magento\Rule\Model\Condition\Context $context
     * @param CouponRepositoryInterface $couponRepository
     * @param Coupon $coupon
     * @param RequestInterface $request
     * @param Session $session
     * @param ManagerInterface $manager
     * @param StoreManagerInterface $storeManager
     * @param ScopeConfigInterface $scopeConfig
     * @param CustomerSession $customerSession
     * @param CustomerRepository $customerRepository
     * @param array $data
     */
    public function __construct(
        \Magento\Rule\Model\Condition\Context $context,
        CouponRepositoryInterface $couponRepository,
        Coupon $coupon,
        RequestInterface $request,
        Session $session,
        ManagerInterface $manager,
        StoreManagerInterface $storeManager,
        ScopeConfigInterface $scopeConfig,
        CustomerSession $customerSession,
        CustomerRepository $customerRepository,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->couponRepository = $couponRepository;
        $this->coupon = $coupon;
        $this->request = $request;
        $this->session = $session;
        $this->manager = $manager;
        $this->storeManager = $storeManager;
        $this->scopeConfig = $scopeConfig;
        $this->customerSession = $customerSession;
        $this->customerRepository = $customerRepository;
    }
    /**
     * Load attribute options
     *
     * @return $this
     */
    public function loadAttributeOptions()
    {
        $attributes = [
            'mod2_customcoupon_subtotal_with_discounts_no_shipping_incl_tax' => __("New Subtotal with discounts no shipping (Incl. Tax)")
        ];
        $this->setAttributeOption($attributes);
        return $this;
    }
    /**
     * Get input type
     * Possible values are: string, numeric, date, select, multiselect, grid, boolean
     *
     * @return string|void
     */
    public function getInputType()
    {
        return 'numeric';
    }
    /**
     * Get value element type
     *
     * We have the value element types as select, text
     * @return string
     */
    public function getValueElementType()
    {
        return 'text';
    }

  
    
      /**
     * @param AbstractModel $model
     * @return bool
     * @throws \Magento\Framework\Exception\LocalizedException
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */

    public function validate(\Magento\Framework\Model\AbstractModel $model)
    {
        try{
            $currentStoreId = $this->storeManager->getStore()->getId() ?? 0;

            $val =$model->getSubtotalInclTax() + $model->getDiscountAmount();
            $model->setData('mod2_customcoupon_subtotal_with_discounts_no_shipping_incl_tax', $val);
            return parent::validate($model);

        } catch (\Exception $e)
        {
            $this->manager->addErrorMessage($e);
        }


    }
}